--!parent
--!encoding=utf-8

--****************************************************************************
-- @file			LSW CORE LIB: THREAD DETACHER
-- @author   	Valentin Schmidt
-- @version  	0.2
--****************************************************************************

property ancestor
property _queue
property _instance

----------------------------------------
-- @constructor (explicitely forced singleton class)
----------------------------------------
on new (me)
	if not voidP(me.script._instance) then return me.script._instance
	me.ancestor = timeout().new("_detachtimer_", 0, #_call, me)
	me._queue = []
	me.script._instance = me
	return me
end

----------------------------------------
-- The only public method
-- @param {symbol} cbHandler
-- @param {object} [cbTarget=_movie]
-- @param {list} [args]
----------------------------------------
on detach (me, cbHandler, cbTarget, args)
	if voidP(cbTarget) then cbTarget = _movie
	if ilk(args)<>#list then args = []
	me._queue.add([cbHandler, cbTarget, args])
	me.period = 1
end

----------------------------------------
-- Called by timeout
-- @callback
----------------------------------------
on _call (me)
	me.period = 0
	q = me._queue.duplicate()
	me._queue = []
	repeat with t in q
		args = t[3]
		case args.count of
			0: call(t[1], t[2])
			1: call(t[1], t[2], args[1])
			2: call(t[1], t[2], args[1], args[2])
			3: call(t[1], t[2], args[1], args[2], args[3])
			4: call(t[1], t[2], args[1], args[2], args[3], args[4])
			otherwise: call(t[1], t[2], args[1], args[2], args[3], args[4], args[5])
		end case
	end repeat
end

----------------------------------------
-- Destructor called by LSW
-- @callback
----------------------------------------
on __destruct (me)
	me.forget()
	me.script._instance = void
end
